<?php
/*
	Plugin Name: Locker Magic
	Plugin URI: https://epicmarketer.com
	Description: Explode your traffic numbers automatically without any additional content!
	Text Domain: locker-magic
	Domain Path: /languages
	Author: Mike Cowles
	Author URI: https://mikecowles.com/
	License: GPLv2
	Version: 1.0.0
*/

// BASIC SECURITY
defined( 'ABSPATH' ) or die( 'Unauthorized Access!' );



if ( !defined('FCA_SLC_PLUGIN_DIR') ) {
	
	//DEFINE SOME USEFUL CONSTANTS
	define( 'FCA_SLC_PLUGIN_VER', '1.0.1' );
	define( 'FCA_SLC_PLUGIN_DIR', plugin_dir_path( __FILE__ ) );
	define( 'FCA_SLC_PLUGINS_URL', plugins_url( '', __FILE__ ) );
	define( 'FCA_SLC_PLUGIN_FILE', __FILE__ );
	define( 'FCA_SLC_PLUGIN_PACKAGE', 'Free' ); //DONT CHANGE THIS, IT WONT ADD FEATURES, ONLY BREAKS UPDATER AND LICENSE
	
	
	
	//LOAD MODULES
	include_once( FCA_SLC_PLUGIN_DIR . '/includes/editor/editor.php' );	
	include_once( FCA_SLC_PLUGIN_DIR . '/includes/locker/locker.php' );	
	include_once( FCA_SLC_PLUGIN_DIR . '/includes/functions.php' );
	
	////////////////////////////
	// SET UP POST TYPE
	////////////////////////////

	//REGISTER CPT
	function fca_slc_register_post_type() {
		
		$labels = array(
			'name' => _x('Lockers Magic','locker-magic'),
			'singular_name' => _x('Locker Magic','locker-magic'),
			'add_new' => _x('Add New','locker-magic'),
			'all_items' => _x('All Lockers Magic','locker-magic'),
			'add_new_item' => _x('Add New Locker Magic','locker-magic'),
			'edit_item' => _x('Edit Locker Magic','locker-magic'),
			'new_item' => _x('New Locker Magic','locker-magic'),
			'view_item' => _x('View Locker Magic','locker-magic'),
			'search_items' => _x('Search Lockers Magic','locker-magic'),
			'not_found' => _x('Locker not found','locker-magic'),
			'not_found_in_trash' => _x('No Lockers found in trash','locker-magic'),
			'parent_item_colon' => _x('Parent Locker:','locker-magic'),
			'menu_name' => _x('Locker Magic','locker-magic')
		);
		
			
		$args = array(
			'labels' => $labels,
			'description' => "",
			'public' => false,
			'exclude_from_search' => true,
			'publicly_queryable' => true,
			'show_ui' => false,
			'show_in_nav_menus' => false,
			'show_in_menu' => false,
			'show_in_admin_bar' => false,
			'menu_position' => 118,
			'menu_icon' => FCA_SLC_PLUGINS_URL . '/assets/icon.png',
			'capability_type' => 'post',
			'hierarchical' => false,
			'supports' => array('title'),
			'has_archive' => false,
			'rewrite' => false,
			'query_var' => true,
			'can_export' => true,
		);
		
		register_post_type( 'contentlocker', $args );
	}
	add_action ( 'init', 'fca_slc_register_post_type' );
	
	//CHANGE CUSTOM 'UPDATED' MESSAGES FOR OUR CPT
	function fca_slc_post_updated_messages( $messages ){
		
		$post = get_post();
		
		$messages['contentlocker'] = array(
			0  => '', // Unused. Messages start at index 1.
			1  => __( 'Locker Magic updated.','locker-magic'),
			2  => __( 'Locker Magic updated.','locker-magic'),
			3  => __( 'Locker Magic deleted.','locker-magic'),
			4  => __( 'Locker Magic updated.','locker-magic'),
			/* translators: %s: date and time of the revision */
			5  => isset( $_GET['revision'] ) ? sprintf( __( 'Locker  Magic restored to revision from %s','locker-magic'), wp_post_revision_title( (int) $_GET['revision'], false ) ) : false,
			6  => __( 'Locker  Magic published.' ,'locker-magic'),
			7  => __( 'Locker  Magic saved.' ,'locker-magic'),
			8  => __( 'Locker  Magic submitted.' ,'locker-magic'),
			9  => sprintf(
				__( 'Locker Magic scheduled for: <strong>%1$s</strong>.','locker-magic'),
				// translators: Publish box date format, see http://php.net/date
				date_i18n( __( 'M j, Y @ G:i' ), strtotime( $post->post_date ) )
			),
			10 => __( 'Locker  Magic draft updated.' ,'locker-magic'),
		);

		return $messages;
	}
	add_filter('post_updated_messages', 'fca_slc_post_updated_messages' );
	
	function fca_slc_remove_screen_options_tab ( $show_screen, $screen ) {
		if ( $screen->id == 'contentlocker' ) {
			return false;
		}
		return $show_screen;
	}	
	add_filter('screen_options_show_screen', 'fca_slc_remove_screen_options_tab', 10, 2);
	
	function fca_slc_tooltip( $text = 'Tooltip', $icon = 'dashicons dashicons-editor-help' ) {
		return "<span class='$icon fca_slc_tooltip' title='" . htmlentities( $text ) . "'></span>";
	}	

}